var pushNotification;
var app = {
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        if (navigator.userAgent.match(/(iPhone|iPod|iPad|Android|BlackBerry)/)) {
            document.addEventListener("deviceready", this.onDeviceReady, false);
        } else {
            this.onDeviceReady();
        }
    },
    onDeviceReady: function() {
        app.receivedEvent('deviceready');
        console.log("Ondeviceready fired.");

        //cordova is ready.






        // iOS
        function onNotificationAPN (event) {
            if ( event.alert )
            {
                navigator.notification.alert(event.alert);
            }

            if ( event.sound )
            {
                var snd = new Media(event.sound);
                snd.play();
            }

            if ( event.badge )
            {
                pushNotification.setApplicationIconBadgeNumber(successHandler, errorHandler, event.badge);
            }
        }
        function tokenHandler (result) {
            // Your iOS push server needs to know the token before it can push to this device
            // here is where you might want to send it the token for later use.
            //alert('device token = ' + result);
        }
// result contains any error description text returned from the plugin call
        function errorHandler (error) {
            alert('error = ' + error);
        }

        var model = "PC";
        if(window.device !== undefined){
            model = window.device.model;
            device = window.device;
            if ( device.platform == 'android' || device.platform == 'Android' || device.platform == "amazon-fireos" ){

                isAndroid = true;
                /* pushNotification.register(
                 successHandler,
                 errorHandler,
                 {
                 "senderID":"replace_with_sender_id",
                 "ecb":"onNotification"
                 });*/
            } else if ( device.platform == 'blackberry10'){

            } else {

                pushNotification = window.plugins.pushNotification;
                try{
                    pushNotification.register(
                        tokenHandler,
                        errorHandler,
                        {
                            "badge":"true",
                            "sound":"true",
                            "alert":"true",
                            "ecb":"onNotificationAPN"
                        });
                }
                catch(e){
                    console.log(e);
                }

                console.log("Registered the APN handler.");
            }

        }
        console.log(model);


    },
    // Update DOM on a Received Event
    receivedEvent: function(id) {
        var parentElement = document.getElementById(id);
        if(parentElement != null){
            var listeningElement = parentElement.querySelector('.listening');
            var receivedElement = parentElement.querySelector('.received');

            listeningElement.setAttribute('style', 'display:none;');
            receivedElement.setAttribute('style', 'display:block;');
        }


        console.log('Received Event: ' + id);
    }
};
