var tap_event = 'click';
var logged_in_user = null;
var locationObj = null;
var dataCache = {};
var dataCacheExpiry = {};
var profileArrayUsing = {};
dataCacheExpiry.profilesNearby = 0;
dataCache.conversations = [];
dataCache.likedProfiles = [];
/*
 cards.push({
 id: "parkDetails",
 title: "Park Details",
 showIconBar: true,
 url: config.baseUrl + "parkDetails",
 beforeShow: null,
 afterShow: null,
 events: function () {

 }
 });
 */

//change any config reqd.

var woofer = {
        dynamicConfig: [],
        slowloop: function(){
            parseAdapter.resetBadgeToZero(installationID);
        },
        loop: function() {
            //this loop is executed every 2 seconds.

            var didLoadMessagesOrFriends = false;
            if (state.cardId == "messaging") {
                parseAdapter.pollAndAddNewMessages();
                didLoadMessagesOrFriends = true;
            }
            if (state.cardId == "messages"){
                parseAdapter.pollAndReloadFriendsList();
                didLoadMessagesOrFriends = true;
            }

            if(!didLoadMessagesOrFriends){
                parseAdapter.getExplicitFriends();
            }
            else{
                var messagesCallback = woofer.displayMessagesBadge;
                var friendsCallback = woofer.displayFriendsBadge;
                parseAdapter.getActivitySince(messagesCallback, friendsCallback);
            }



            var now = new moment();
            if(!dataCacheExpiry.position || dataCacheExpiry.position < now){
                woofer.tryGetLocation(function(){
                    parseAdapter.getParksNearby();
                    if(Parse.User.current()){
                        parseAdapter.getProfilesNearby();
                    }
                });
            }

            if(Parse.User.current()){
                if (!dataCacheExpiry.profilesNearby || dataCacheExpiry.profilesNearby < now){
                    parseAdapter.getProfilesNearby();
                }
                if(!dataCacheExpiry.likesToMe || dataCacheExpiry.likesToMe < now){
                    var thenEnumerateFriends = true;
                    parseAdapter.getLikesToMe(thenEnumerateFriends);

                }
            }

        },
    fastloop: function(){

        if(preloadQueue.length > 0){
            var img = preloadQueue.pop();

            //console.log("preloading " + img);
            $("#preloader").attr('src', img);
        }

        if($(".active_card").find(".wait-1-image").length > 0){
            //every 500ms
            state.transition = state.transition == 1?2 : 1;
            var img1 = $(".wait-1-image > img");
            var img2 = $(".wait-2-image > img");
            if(state.transition == 2) {

                if (img1.hasClass("wait-1")) {
                    img1.removeClass("wait-1").addClass("wait-2");
                }
                else if (img1.hasClass("wait-2")) {
                    img1.removeClass("wait-2").addClass("hide");
                }
                else {
                    img1.removeClass("hide").addClass("wait-1")
                }
            }
            else{

                if(img2.hasClass("wait-1")){
                    img2.removeClass("wait-1").addClass("wait-2");
                }
                else if(img2.hasClass("wait-2")){
                    img2.removeClass("wait-2").addClass("hide");
                }
                else{
                    img2.removeClass("hide").addClass("wait-1")
                }
            }
        }

        },
    nextPhoto: function(direction){
        $(".profilesAround").find(".dog_photo").find("img").attr('src',"");
        //user has swiped at a sniff photo.
        var active = dataCache.currentSniffProfile.activePhoto;
        var id = active.substr(active.length - 1,1);
        var idNo = parseInt(id);
        if(isNaN(idNo)){
            idNo = 1;
        }
        if(!isNaN(idNo)){
            idNo += direction;
            if(idNo == 0) idNo = 4;
            if(idNo <= 1) idNo = "";
            if(idNo >= 5) idNo = "";
            var active = "photo" + idNo;

            console.log(direction + " " + active);
            var photo = dataCache.currentSniffProfile.dog.get(active);
            dataCache.currentSniffProfile.activePhoto = active;
            if(photo == undefined){
                this.nextPhoto(direction);
                return;
            }
            $(".profilesAround").find(".dog_photo").find("img").attr('src', dataCache.currentSniffProfile.dog.get(active).url());

            // $(".profilesAround .dog_photo img").css({marginLeft: ($(".profilesAround .dog_photo").width() - $(".profilesAround .dog_photo img").width())/2});

        }
    },
        setActive: function(id){
            $(".icon-bar").children().removeClass("active");
            $("#" + id).addClass("active");
        },
        pushErrorsToUI: function (result) {
            var errors_formatted = "<ul>";
            _.each(result.validationMessages, function (error) {
                errors_formatted += "<li>" + error + "</li>";
            });
            $(".form-group").removeClass("failed");
            _.each(result.failedFields, function (field) {
                $(field).parent().addClass("failed");
            });
            errors_formatted += "</ul>";
            if(errors_formatted.indexOf("XMLHttpRequest failed") > -1){

                swal("Oops", "It looks like you're offline! Reconnect to Wi-Fi or cellular data and try again.", "error");
            }
            else{

                swal("Oops", "Please correct these errors:<br>" + errors_formatted, "error");
            }
        },
    resetReportProblemForm: function(){

        var options = woofer.dynamicConfig["problemCategories"];
        if(options == undefined){
            window.setTimeout(function(){
                if(getParameterByName("card") == "report-a-problem"){

                    loadCard("report-a-problem");
                }
            }, 1000);
            return;
        }
        options = options.split("|");
        var opt = "";
        for(var i = 0; i < options.length; i++){
            opt = opt + "<button class='woofer rap-category'>" + options[i] + "</button>";
        }
        $(".dropdown-items").html(opt);
        $(".submit-problem").removeAttr('disabled');
        $("#problem-text-body").val("");
        $(".rap-dropdown-selected").text("Please Select");
    },
        registerUIEvents: function () {
            $("body").on(tap_event,".back-button-no-logo, .arrow", function () {
                if(disableBack) return;
               if(getParameterByName("card") == "addAPark" ||
                   getParameterByName("card") == "parkDetails" ){
                   disableBack = true;
                   window.setTimeout(function(){disableBack = false;},1000);
                   loadCard("findAPark");
               }
                else{
                    if(getParameterByName("card") == "messaging"){
                        parseAdapter.pollAndReloadFriendsList();
                    }
                   console.log("Back event hit.");
                   history.go(-1);
               }
            });
            console.log("Back event added.");
            $(".icon-bar div").on(tap_event, function () {
                var id = $(this).attr('id');
                loadCard(id);
            });
            $("body").on(tap_event,".settings-cog",function(){
                loadCard("menu");
            });
            $("body").on(tap_event,".park-cog",function(){
                loadCard("menu");
            });
            $("body").on(tap_event,".nominate-park",function(){
                if(dataCache.parksTooClose.length > 1){
                    swal({title: "Are you sure?", text: "There are " + dataCache.parksTooClose.length + " parks nearby - are you sure you want to add another?<br><button class='woofer yes-add-another-park'>Yes</button><br /><button class='woofer nevermind'>No, nevermind</button>", showConfirmButton: false });
                    return;
                }
                if(dataCache.parksTooClose.length == 1){
                    swal({title: "Are you sure?", text: "A park called " + dataCache.parksTooClose[0].attributes["Name"] + " is nearby. Are you sure you want to add another?<br><button class='woofer yes-add-another-park'>Yes</button><br /><button class='woofer nevermind-open-park' data-park-exists-id=" + dataCache.parksTooClose[0].id + ">Go to park</button>", showConfirmButton: false });
                    return;
                }
                loadCard("addAParkLoading");
            });
            $("body").on(tap_event, '.yes-add-another-park', function(){

                window.swal_closeModal();
                loadCard("addAParkLoading");
            });

            $.each(cards, function (it, card) {
                //register jquery events.
                card.events();
            });
        },
    loadRecentVisitorsToPark: function(park, callback){
            $("#park-recent-visitors").html("");
            var visitors =_.sortBy(park.visitors, function(v){
                return v.createdAt;
            });
            visitors = _.uniq(visitors, false, function(v){
                return v.attributes.userId;
            });
        visitors = _.filter(visitors, function(v){
            return v.profile;
        })
            visitors = _.first(visitors, 4);
            _.each(visitors, function(visitor){
                    var coverPhoto = visitor.profile.attributes['coverPhoto'];
                if(coverPhoto){
                    $("#park-recent-visitors").append(
                        "<div class='visiting-dog-wrapper' style=\"background-image: url('" + visitor.profile.attributes[coverPhoto].url() + "'); background-size: cover; background-position: center;\"><!-- <img class='visiting-dog' src='" + visitor.profile.attributes[coverPhoto].url() + "'/> --></div>");

                }

            });
        if(callback){
            callback();
        }
        },
    unfriend: function(myId, theirId){
        var Like = Parse.Object.extend("Likes");
        var query = new Parse.Query(Like);
        query.equalTo("senderId", myId);
        query.equalTo("receiverId", theirId);
        query.find({
            success: function(results) {
                for (var i = 0; i < results.length; i++) {
                    var object = results[i];
                    object.destroy();
                }

                //remove from cached likes by me
                dataCache.LikesByMe = _.reject(dataCache.LikesByMe, function(lbm){
                    return (lbm.attributes.receiverId == theirId);
                });
                //remove from cached friends
                dataCache.friends = _.reject(dataCache.friends, function(fbm){
                    return (fbm.id == theirId);
                });

                if(getParameterByName("card") == "friends"){
                    loadCard("friends");
                }
            }});
        var Friend = Parse.Object.extend("Friends");
        var query = new Parse.Query(Friend);
        query.equalTo("friend1", myId);
        query.equalTo("friend2", theirId);
        query.find({
            success: function(results) {
                for (var i = 0; i < results.length; i++) {
                    var object = results[i];
                    object.destroy();
                }}});

        var query = new Parse.Query(Friend);
        query.equalTo("friend2", myId);
        query.equalTo("friend1", theirId);
        query.find({
            success: function(results) {
                for (var i = 0; i < results.length; i++) {
                    var object = results[i];
                    object.destroy();
                }}});


    },
        loadBreeds: function () {
            if (dataCache.breeds) {
                var optionsBox = "";
                optionsBox += "<option selected>Select Breed:</option>";
                _.each(dataCache.breeds, function (b) {
                    optionsBox += "<option>" + b.attributes.breedName + "</option>";
                });
                var breedSelect = $(".breed-options");
                breedSelect.html(optionsBox);
            }
        },
        loadSniffProfile: function(direction){

            var seq = getParameterByName("sequenceInSet");
            seq = parseInt(seq);
            if(isNaN(seq)) seq= 0;
            seq +=direction;
            if(seq < 0) seq = profileArrayUsing.length - 1;
            if(seq >= profileArrayUsing.length){

                if(profileArrayUsing.length == 0){
                    swal("","It looks like you've liked all the profiles we have available! Please check back again later.");


                    var tpl = _.template($("#waitingForData").html());
                    var compiled = tpl({});
                    $(".active_card").html("").append(compiled);


                        return false;
                }
                else{
                    swalevent = function(){
                        seq = 0;
                        console.log("loading profile " + seq);
                        var loadAlreadySniffed = getParameterByName("loadAlreadySniffed");
                        loadCard("profilesAround", {params: {sequenceInSet: seq, loadAlreadySniffed: loadAlreadySniffed}});
                    }
                    swal("", "You have finished sniffing all dogs in the area! Press OK to revisit the ones you've sniffed before.");
                }

            }
            else{
                console.log("loading profile " + seq);
                var loadAlreadySniffed = getParameterByName("loadAlreadySniffed");
                loadCard("profilesAround", {params: {sequenceInSet: seq, loadAlreadySniffed: loadAlreadySniffed}});
            }

        },
    loadFriend: function(sequenceInSet){
        var profile = dataCache.friends[sequenceInSet];
        if(profile.explicit_friendship){
            console.log(profile.explicit_friendship.updatedAt);
        }

        /*woofer.displayPackProfile(profile);*/

        var coverPhoto = "";
        if(!profile.dog){
            state.swiping = false;
            return;
        }
        if(profile.dog){
            var age = profile.dog.get("dateOfBirth");
            if(age){

                var yo = moment(age).fromNow(true).replace("years","").trim();
                if(yo.indexOf("months") > 0){
                    yo = 0;
                }
                profile.dog.age_yo = yo;
                /*
                 age_field.attr('data-age', yo);
                 age_field.attr('data-dateOfBirth', moment(age).format("YYYY-MM-DD"));*/
            }


            coverPhoto = profile.dog.get("coverPhoto");
            profile.activePhoto = coverPhoto;

            if(profile.dog.get(coverPhoto)) {
                profile.dog.coverPhoto =profile.dog.get(coverPhoto).url();
            }
            else{
                profile.dog.coverPhoto = "";
            }

            //preload all photos for swiping.
            try{preloadImage(profile.dog.get("photo").url());}catch(e){}
            try{preloadImage(profile.dog.get("photo2").url());}catch(e){}
            try{preloadImage(profile.dog.get("photo3").url());}catch(e){}
            try{preloadImage(profile.dog.get("photo4").url());}catch(e){}

        }
        else{
            profile.dog = {};
            profile.dog.coverPhoto = "";
        }



        var position = profile.attributes.location;
        var distance_away = -1;
    if(dataCache.position && dataCache.position.coords && position){

        distance_away = distanceBetween(dataCache.position.coords.latitude, dataCache.position.coords.longitude, position.latitude, position.longitude);
        if(distance_away > 0 && distance_away < 1){
            distance_away = "< 1km";
        }
        else{
            distance_away = Math.round(distance_away) + "km";
        }
        console.log(distance_away);
    }

        var tpl = _.template($("#friendsTemplate").html());
        profile.currentFriendInPack = sequenceInSet;
        var compiled = tpl({profile:profile, distance_away: distance_away});
        $(".friendsList").html(compiled);
    },
        showAlreadyLikedProfiles: function(){
            var alreadyLikedAction = function() {
                state.alreadyProcessingSequence = false;
                window.setTimeout(function(){$(".in-bowl").removeClass("active");},300);
                loadCard("profilesAround", {params: {sequenceInSet: 0, loadAlreadySniffed: true}});
                return false;
            };
            if(!dataCacheExpiry.alreadyLikedProfiles || dataCacheExpiry.alreadyLikedProfiles < new moment()){
                // timeout for the already liked profiles warning is over - show it again.
                // stops app bugging the hell out of someone just going through profiles.
                dataCacheExpiry.alreadyLikedProfiles = new moment().add(5,'minutes');
                    swalevent = alreadyLikedAction;
                    swal("","You have finished sniffing all dogs in the area! Press OK to revisit the ones you've sniffed before.");

            }
            else{
                alreadyLikedAction();
            }

        },
    markerTapped: function(map, marker){
        if(marker.park){
            var id = marker.park.id;
            loadCard("parkDetails", {params: {parkId: id}});
        }

    },
    loadPinForPark: function(park, map, pintype){
        // debugger;
        var location = park.attributes.Location;

        var marker = woofer.loadPinForLatLng(location.latitude, location.longitude, map, pintype);
        marker.park = park;
        park.marker = marker;

    },
    loadPinForLatLng: function(lat, lng, map, pintype){
        var latlng = new google.maps.LatLng(lat, lng);
        var icon = null;
        console.log("placing pin " + pintype + " for lat " + lat + " lng " + lng);
        if(pintype == "verified"){
            icon = new google.maps.MarkerImage('http://files.parsetfss.com/4ef54ecb-d5ad-4dba-bb8d-5fd6425798d2/tfss-1e7e36ba-2e98-4597-85a8-4f5495d84582-marker.png', null, null, null, new google.maps.Size(21,30));

        }
        else{
            icon = new google.maps.MarkerImage('http://files.parsetfss.com/4ef54ecb-d5ad-4dba-bb8d-5fd6425798d2/tfss-b24ff47b-35d4-487c-99e4-02161b574c35-unverified-marker.png', null, null, null, new google.maps.Size(21,30));

        }
        var marker = new google.maps.Marker({
            position:latlng,
            map:map,
            icon: icon
        });
        google.maps.event.addListener(marker, tap_event, function(){
            woofer.markerTapped(map, marker);
        });
        return marker
    },
    getDogPhoto: function(photoSourceType, fieldToUpdate){
        if (navigator) {

            var mp = $(".myProfile");
            var cameraSuccess = function (base64) {
                window.setTimeout(function () {
                    console.log("Camera success, allocating to dog_photo. Field to update is " + fieldToUpdate);
                    if(dataCache.profile.get("coverPhoto") == undefined){
                        dataCache.profile.set("coverPhoto","photo")
                    }
                    console.log(base64.substr(0,1000));
                    if (dataCache.profile == undefined) {
                        var Profile = Parse.Object.extend("UserProfile");
                        dataCache.profile = new Profile();
                        dataCache.profile.set("coverPhoto","photo");
                        dataCache.profile.set("userId", Parse.User.current().id);
                        debugger;
                    }
                    if(dataCache.profile.get("coverPhoto") == fieldToUpdate){
                        var imgtag = mp.find(".dog_photo").find("img");
                        imgtag.attr('src', "data:image/jpeg;base64," + base64);
                        imgtag.removeClass("no_photo");
                    }
                    $("." + fieldToUpdate).attr('src', "data:image/jpeg;base64," + base64);
                    console.log("Allocated to dog_photo.");
                    console.log(base64.length);
                    var fileName = makeid() + ".jpg";
                    var file = new Parse.File(fileName, {base64: base64});
                    console.log("Attempting to save file " + fileName );
                    file.save().then(
                        function(){

                            console.log("Attaching to profile.");
                            dataCache.profile.set(fieldToUpdate, file);
                            console.log("Saving profile.");
                            dataCache.profile.save().then(
                                function(){
                                    parseAdapter.tryGetProfile();
                                    console.log("Parse saved.");
                                }, function(error){
                                    console.log(error);
                                }
                            );
                        },
                        function(error){
                            console.log(error.code);
                        });


                    console.log("File saved?");

                }, 100)
            };
            var cameraError = function (message) {
                window.setTimeout(function () {
                    swal("",message);
                }, 100);
            };

            if (navigator.camera) {
                var cameraOptions = {
                    sourceType: photoSourceType,
                    quality: parseInt(woofer.dynamicConfig["cameraQuality"]),
                    destinationType: Camera.DestinationType.DATA_URL,
                    targetWidth: 400,
                    targetHeight: 600,
                    correctOrientation: true
                };
                console.log("PST:" + photoSourceType);
                console.log("Quality: " + cameraOptions.quality);
                navigator.camera.getPicture(cameraSuccess, cameraError, cameraOptions)

            }
            else {
                // probably debugging on PC, or camera access disabled.
                cameraSuccess("NO CAMERA");
            }

        } else {
            alert("No navigator obj");

        }
    },
        displayMyProfile: function () {
            state.canSaveProfile = true;
            var mp = $(".myProfile");

            mp.find(".dogname > .name").text("(Enter name)");
            mp.find(".dogname > .breed").text("(Select Breed)");
            var name_field = mp.find(".name");
            var breed_field = mp.find(".breed");
            var gender_field = mp.find(".gender");
            var microchipped_field = mp.find(".microchipped");
            var desexed_field = mp.find(".desexed");
            var trained_field = mp.find(".trained");
            var vaccinated_field = mp.find(".vaccinated");
            var photo_field =  mp.find(".dog_photo").find("img");
            var age_field = mp.find(".age");
            if (dataCache.profile) {
                var p = dataCache.profile;
                var gender = p.get("sex");
                var dogname = p.get("name");
                var breed = p.get("breed");
                var age = p.get("dateOfBirth");
                var microchipped = p.get("microchipped");
                var desexed = p.get("desexed");
                var trained = p.get("trained");
                var vaccinated = p.get("vaccinated");
                var coverPhotoField = p.get("coverPhoto");
                if(coverPhotoField == "") coverPhotoField = "photo";
                var photo = p.get(coverPhotoField);

                if (dogname != "") {
                    name_field.text(dogname);
                }
                else {
                    name_field.text("(Enter name)");
                }
                if (breed != "") {
                    breed_field.text(breed);
                }
                else {
                    breed_field.text("(Enter breed)");
                }
                if (gender == true) gender_field.attr('data-gender', 'male');
                if (gender == false) gender_field.attr('data-gender', 'female');

                if (microchipped == true) microchipped_field.attr('data-microchipped', 'true');
                if (desexed == true) desexed_field.attr('data-desexed', 'true');
                if (trained == true) trained_field.attr('data-trained', 'true');
                if (vaccinated == true) vaccinated_field.attr('data-vaccinated', 'true');

                if(age){

                    var yo = moment(age).fromNow(true).replace("years","").trim();
                    if(yo.indexOf("months") > 0){
                        yo = 0;
                    }
                    age_field.attr('data-age', yo);
                    age_field.attr('data-dateOfBirth', moment(age).format("YYYY-MM-DD"));
                }

                if(photo != undefined){
                    photo_field.attr('src', photo.url());
                    photo_field.removeClass('no_photo');
                }
            }
            else{
                name_field.text("(Enter name)");
                breed_field.text("(Enter breed)");
            }

            woofer.setHeightKennel();

            if($(".myProfile .dogname .name").prop('scrollWidth') > $(".myProfile .dogname .name").width() ||
                $(".myProfile .dogname .name").height() > 41
            ){
                $(".myProfile .dogname .name").css({fontSize:"12pt"});

            }


        },
        saveMyProfile: function () {
            // If parse is still loading profile, don't make a duplicate.
            if(!state.canSaveProfile){
                console.log("Profile hasn't finished loading - can't save yet.");
                return;
            }
            if (dataCache.profile == undefined) {
                var Profile = Parse.Object.extend("UserProfile");
                dataCache.profile = new Profile();
                dataCache.profile.set("userId", Parse.User.current().id);
                debugger;
            }
            var mp = $(".myProfile");
            var gender = mp.find(".gender").attr('data-gender');
            if (gender != "undefined") dataCache.profile.set("sex", gender == "male");

            if(dataCache.profile.get("coverPhoto") == ""){
                dataCache.profile.set("coverPhoto","photo");
            }

            var microchipped = mp.find(".microchipped").attr('data-microchipped');
            if (microchipped != "undefined") dataCache.profile.set("microchipped", microchipped == "true");

            var desexed = mp.find(".desexed").attr('data-desexed');
            if (desexed != "undefined") dataCache.profile.set("desexed", desexed == "true");

            var trained = mp.find(".trained").attr('data-trained');
            if (trained != "undefined") dataCache.profile.set("trained", trained == "true");

            var vaccinated = mp.find(".vaccinated").attr('data-vaccinated');
            if (vaccinated != "undefined") dataCache.profile.set("vaccinated", vaccinated == "true");

            var dob = mp.find(".age").attr('data-dateofbirth');
            if(dob != undefined){

                var dobmoment = new moment(dob, "YYYY-MM-DD").toDate();
                dataCache.profile.set("dateOfBirth", dobmoment);
            }

            var name =  mp.find(".name").text();
                var breed = mp.find(".breed").text();
            if(name == "(Enter name)"){
                name = ""
            }
            if(breed == "null") breed = "";
            dataCache.profile.set("name",name);
            dataCache.profile.set("breed", breed);
            dataCache.profile.save();
            parseAdapter.subscribe(dataCache.profile.id);
            parseAdapter.subscribe(Parse.User.current().id);
            // Subscribe the known device ID to this user profile as well, so people communicating with
            // this profile get to the device.

        },
    fixCentrePhoto: function(){
        var usable_height = $(window).height() - $(".active_card").find(".button-row").height() - $(".active_card").find(".header").height() - 90;
        var card = getParameterByName("card");

        var selector = ""; //friendsList
        var parent_selector = "";
        switch(card){
            case "friends":
                parent_selector = ".friendsList .dog_photo";
                selector = ".friendsList .dog_photo img";
                break;
            case "profilesAround":
                parent_selector = ".profilesAround .dog_photo";
                selector = ".profilesAround .dog_photo img";
                break;
            case "myProfile":
                parent_selector = ".myProfile .dog_photo";
                selector = ".myProfile .dog_photo img";
                break;
        }
        $(".dog_photo").height(usable_height - 150);
        if(parent_selector == "" || selector == "") return;
        var actual_width = $(selector).width();
        if(actual_width == 0){
            window.setTimeout(woofer.fixCentrePhoto, 200);
            return;
        }
        if(actual_width < 185){
            $(".dog_photo").height(usable_height -80);
            actual_width = $(selector).width();
        }
        if(actual_width < 185){
            $(".dog_photo").height(usable_height -60);
            actual_width = $(selector).width();
        }
        $(selector).css({marginLeft: ($(parent_selector).width() - actual_width)/2});

        //check width again!
        if($(selector).width() != actual_width){
            woofer.fixCentrePhoto();
        }

    },
        setHeightKennel: function () {
            var card_height = $(window).height() - $(".active_card").find(".button-row").height();
            $(".active_card").height(card_height - 50);
            var usable_height = $(window).height() - $(".active_card").find(".button-row").height() - $(".active_card").find(".header").height() - 90;
            window.setTimeout(function(){
                woofer.fixCentrePhoto();
            },200);
            $(".swipe-area").height(usable_height - 150);
            $(".chat-contents").height(usable_height - 80);
            $(".friend-wrapper").height(usable_height);
        },
        userLoggedIn: function () {
            //first load - logged_in_user is set.
            if (Parse.User.current().attributes.termsAndConditionsAgreedDate) {

                woofer.userAllowedIn();
            }
            else {
                woofer.userMustAcceptTerms();
            }
        },
        enumerateFriends: function(){
            if(
                dataCache.LikesToMe == undefined ||
                (dataCacheExpiry.likesToMe && dataCacheExpiry.likesToMe < new moment())){
                parseAdapter.getLikesToMe();
            }
            if(!dataCache.explicitFriends){
                parseAdapter.getExplicitFriends(); // loads friends from the friends table into datacache.friends.

            }
            console.log("Enumerating friends.");
            //freshen up friends list - if they got removed for example.
            dataCache.friends = [];
            _.each(dataCache.LikesToMe, function(like){
                //console.log(like.id);
                var likeByMe = _.find(dataCache.LikesByMe, function(lbm){
                    return like.attributes.senderId == lbm.attributes.receiverId;
                });
                if(like.attributes.sentiment == true && likeByMe && likeByMe.attributes.sentiment == true){
                    // this is a friend. We should have their profile in the friends cache.
                    _.each(dataCache.likedProfiles, function(profile){
                        if(profile.id == like.attributes.senderId){
                            // this is the friend.

                            // remove if already in array.
                            dataCache.friends = _.reject(dataCache.friends, function(friend){return friend.id == like.attributes.senderId;});

                            // add profile to friends array.
                            dataCache.friends.push(profile);
                        }
                    });

                    // remove anybody from friends list that no longer is a friend.
                    var friendsToRemove = [];
                    _.each(dataCache.friends, function(friend){
                       // make sure there is a like to me.
                        var haveLike = false;
                        _.each(dataCache.LikesToMe, function(ltm){
                            if(ltm.attributes.senderId == friend.id){
                                haveLike = true;
                            }
                        });
                            if(!haveLike){
                                friendsToRemove.push(friend.id);
                            };
                    });

                    dataCache.friends = _.reject(dataCache.friends, function(f){
                        for(var i = 0; i < friendsToRemove.length; i++){
                            if(friendsToRemove[i] == f.id) return true;
                        }
                        return false;
                    });
                }
            });
            woofer.reloadExplicitFriendships();
        },
        reloadExplicitFriendships: function(){

            //friends list is refreshed. Populate with friendship record also, for sorting among other things.
            _.each(dataCache.friends, function(f){
                var explicit_friendship = _.find(dataCache.explicitFriends, function(ef){
                    return ef.attributes.friend2 == f.id;
                });
                f.explicit_friendship = explicit_friendship;
            })
        },
        userMustAcceptTerms: function () {
            loadCard("terms");
        },
        userAllowedIn: function () {



            parseAdapter.getParksNearby();
            parseAdapter.getProfilesNearby();
            parseAdapter.getLikesByMe();

            loadCard("myProfile");
        },
        displayMessagesBadge: function(count){
            if(count > 0){
                $(".icon-bar-messages .badge").text(count).show();
            }
            else{
                $(".icon-bar-messages .badge").text(count).hide();
            }
        },
        displayFriendsBadge: function(count){
            if(count > 0){
                $(".icon-bar-friends .badge").text(count).show();
            }
            else{
                $(".icon-bar-friends .badge").text(count).hide();
            }
        },
        tryGetLocation: function (callback) {
            console.log("Trying to get location.");
            // give the function time to run in case of long time out.
            dataCacheExpiry.position = new moment().add(20, 'seconds');
                if (navigator.geolocation) {
                    var geoSuccess = function (position) {

                        dataCache.looksLikeLocationDisabled = true;
                        locationObj = position;
                            console.log("Retrieved location.");
                        //every time we successfully get location, save it to update sniff etc.
                        parseAdapter.saveLocation(position);
                        dataCache.position = position;
                        dataCacheExpiry.position = new moment().add(5, 'minutes');
                        if (callback) {
                            callback(position);
                        }
                        return true;
                    };
                    var geoError = function (error) {
                        if((error.code == 1 || error.code == 2) && !dataCache.hasSeenLocationError){
                            dataCache.looksLikeLocationDisabled = true;
                            swal("Location services disabled","Please enable Location Services to enjoy all the features of woofer.");
                            dataCache.hasSeenLocationError = true;
                        }
                        switch(state.cardId){
                            case "findAPark":
                            case "profilesAround":
                            case "addAPark":
                                //you can't use this card.
                                loadCard("no-location");
                                break;
                        }
                        return false;
                    };
                    try{
                        if(isAndroid){
                            navigator.geolocation.getCurrentPosition(geoSuccess, geoError,{timeout:8000});
                        }
                        else{
                            navigator.geolocation.getCurrentPosition(geoSuccess, geoError);
                        }

                    }
                    catch(err){
                        alert('location disabled.');
                        console.log("geo err");
                        console.log(err);

                    }


                }
                else {
                    console.log("No navigator geo.");
                    // probably debugging on PC.
                    location.lat = -37.8136;
                    location.lng = 144.9631;
                    location.time = 0;
                    return true;
                }
        },
        loadProfilesAroundCardIfOnWaitingScreen: function(){
                if(state.loadingLikesToMe == false && state.loadingLikesByMe == false){
                    if(state.alreadyLoadingProfilesAfterWaitingScreen) return;
                    state.alreadyLoadingProfilesAfterWaitingScreen = true;;
                    if(state.waitingForProfiles){
                        state.waitingForProfiles = false;
                    }
                    woofer.enumerateFriends();
                    if(state.cardId == "profilesAround"){
                       //if user is already on a sequence, leave them alone

                        var sequenceInSet = getParameterByName("sequenceInSet");
                        if(sequenceInSet == null){
                            loadCard("profilesAround");
                        }else{

                        }
                    }
                    if(state.cardId == "messages") loadCard("messages", {isReload: true,params:{cameFromReloadingMessages: true}});
                    if(state.cardId == "friends") loadCard("friends", {isReload: true, params: {sequenceInSet: getParameterByName("sequenceInSet")}});
                    state.alreadyLoadingProfilesAfterWaitingScreen = false;

                }
            else{
                    console.log(
                        "loading likes to me: " + state.loadingLikesToMe +
                    "loading likes by me: " + state.loadingLikesByMe);
                }
        }
    };

